import { renderless, api } from '@opentinyvue/vue-renderless/select-mobile/vue';
import { defineComponent, $prefix, setup, $props } from '@opentinyvue/vue-common';
import { iconCheck, iconYes, iconCheckedSur, iconHalfselect, iconSearch, iconClose } from '@opentinyvue/vue-icon';
import Button from '@opentinyvue/vue-button';
import ActionSheet from '@opentinyvue/vue-action-sheet';
import Exception from '@opentinyvue/vue-exception';
import Input from '@opentinyvue/vue-input';
import Cell from '@opentinyvue/vue-cell';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var __vue2_script$1 = defineComponent({
  emits: ["click"],
  components: {
    IconCheck: iconCheck(),
    IconYes: iconYes(),
    IconCheckedSur: iconCheckedSur(),
    IconHalfselect: iconHalfselect()
  },
  props: ["selected", "ellipsis", "multiple", "option", "textField", "textField2", "textField3"]
});
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "flex items-start leading-5.5 py-3 cursor-pointer select-none",
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, [_vm.multiple ? _c(_vm.selected ? "icon-checked-sur" : "icon-check", {
    tag: "component",
    class: ["flex-none mt-1 mr-2", _vm.selected ? "fill-color-brand" : "fill-color-icon-disabled"],
    attrs: {
      "custom-class": "w-4.5 h-4.5"
    }
  }) : _vm._e(), _c("div", {
    class: ["flex-auto flex w-full text-sm", {
      "truncate": _vm.ellipsis
    }, {
      "text-color-brand": !_vm.multiple && _vm.selected
    }]
  }, [_vm._t("default", function() {
    return [_c("div", {
      class: ["flex-auto", {
        "truncate": _vm.ellipsis
      }]
    }, [_c("div", {
      staticClass: "flex"
    }, [_c("div", {
      class: [{
        "min-w-[3.75rem]": !_vm.textField3
      }, {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(_vm._s(_vm.option[_vm.textField]))]), _vm.textField2 ? _c("div", {
      class: ["ml-5 text-color-text-placeholder", {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.option[_vm.textField2]) + " ")]) : _vm._e()]), _vm.textField3 ? _c("div", {
      class: ["text-color-text-placeholder", {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.option[_vm.textField3]) + " ")]) : _vm._e()]), _c("div", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: !_vm.multiple && _vm.selected,
        expression: "!multiple && selected"
      }],
      staticClass: "flex flex-none w-5 items-center justify-center ml-2"
    }, [_c("IconYes", {
      staticClass: "fill-color-brand",
      attrs: {
        "custom-class": "w-5 h-5"
      }
    })], 1)];
  })], 2)], 1);
};
var staticRenderFns$1 = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var Option = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var __vue2_script = defineComponent({
  name: $prefix + "SelectMobile",
  emits: ["click", "search-click", "update:visible", "update:text", "update:modelValue", "confirm", "close"],
  components: {
    TinyActionSheet: ActionSheet,
    TinyOption: Option,
    TinyButton: Button,
    TinyException: Exception,
    IconCheck: iconCheck(),
    IconCheckedSur: iconCheckedSur(),
    IconHalfselect: iconHalfselect(),
    IconSearch: iconSearch(),
    IconClose: iconClose(),
    TinyInput: Input,
    TinyCell: Cell
  },
  props: _extends({}, $props, {
    menus: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    modelValue: [Number, String, Array],
    visible: {
      type: Boolean,
      default: false
    },
    ellipsis: {
      type: Boolean,
      default: false
    },
    valueField: {
      type: String,
      default: "id"
    },
    textField: {
      type: String,
      default: "label"
    },
    textField2: {
      type: String,
      default: ""
    },
    textField3: {
      type: String,
      default: ""
    },
    title: String,
    textSplit: {
      type: String,
      default: "; "
    },
    showHeader: {
      type: Boolean,
      default: true
    },
    showFooter: {
      type: Boolean,
      default: false
    },
    multiple: Boolean,
    searchConfig: {
      type: Object,
      default: function _default2() {
        return {
          options: [],
          searchMethod: null,
          openSearchSlot: false
        };
      }
    },
    lockScroll: {
      type: Boolean,
      default: true
    },
    mode: {
      type: String,
      default: "",
      validator: function validator(val) {
        return ["", "form"].includes(val);
      }
    },
    placeholder: String
  }),
  setup: function setup$1(props, context) {
    return setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    attrs: {
      "data-tag": "tiny-select-mobile"
    }
  }, [_vm.mode === "form" ? _c("tiny-cell", {
    attrs: {
      "placeholder": _vm.placeholder,
      "data": _vm.state.selectedLabel
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("update:visible", true);
      }
    }
  }) : _vm._e(), _c("tiny-action-sheet", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.visible,
      expression: "visible"
    }],
    attrs: {
      "tiny_mode": "mobile-first",
      "title": _vm.title,
      "lock-scroll": _vm.lockScroll,
      "visible": _vm.state.toggle,
      "show-header": !_vm.state.search.show,
      "show-footer": _vm.multiple,
      "custom-class": [{
        "min-h-[90%]": _vm.state.search.show
      }, {
        "pb-4": _vm.state.search.show && _vm.multiple
      }]
    },
    on: {
      "update:visible": function updateVisible($event) {
        return _vm.$emit("update:visible", $event);
      },
      "close": _vm.hide
    },
    scopedSlots: _vm._u([{
      key: "header-left",
      fn: function fn() {
        return [_c("IconSearch", {
          staticClass: "cursor-pointer",
          attrs: {
            "custom-class": "h-5 w-5"
          },
          on: {
            "click": function click($event) {
              return _vm.searchBoxToggle(true);
            }
          }
        })];
      },
      proxy: true
    }, {
      key: "footer",
      fn: function fn() {
        return [_vm.multiple ? _c("tiny-button", {
          staticClass: "flex-1 mx-4 sm:mx-0",
          attrs: {
            "tiny_mode": "mobile-first",
            "type": "primary",
            "reset-time": 0
          },
          on: {
            "click": _vm.confirm
          }
        }, [_vm._v(_vm._s(_vm.t("ui.button.confirm")))]) : _vm._e()];
      },
      proxy: true
    }])
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.state.search.show,
      expression: "!state.search.show"
    }],
    class: ["flex flex-col px-4"],
    attrs: {
      "data-tag": "tiny-select-mobile-content"
    }
  }, [_vm.multiple ? _c("div", {
    class: ["flex items-start leading-5.5 py-3 cursor-pointer select-none"],
    attrs: {
      "data-tag": "tiny-select-mobile-multiple"
    },
    on: {
      "click": _vm.allCheckHandler
    }
  }, [_vm.multiple ? _c(_vm.state.checkList.length === 0 ? "icon-check" : _vm.state.checkList.length === _vm.menus.length ? "icon-checked-sur" : "icon-halfselect", {
    tag: "component",
    class: ["flex-none mt-1 mr-2", _vm.state.checkList.length ? "fill-color-brand" : "fill-color-icon-disabled"],
    attrs: {
      "custom-class": "w-4.5 h-4.5"
    }
  }) : _vm._e(), _c("div", {
    class: ["flex-auto", {
      "truncate": _vm.ellipsis
    }],
    attrs: {
      "data-tag": "tiny-select-mobile-ellipsis"
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.base.all")) + " ")])], 1) : _vm._e(), _vm._l(_vm.menus, function(item, index) {
    return _c("tiny-option", {
      key: item[_vm.valueField],
      attrs: {
        "multiple": _vm.multiple,
        "ellipsis": _vm.ellipsis,
        "text-field": _vm.textField,
        "text-field2": _vm.textField2,
        "text-field3": _vm.textField3,
        "option": item,
        "selected": _vm.isSelected(item)
      },
      on: {
        "click": function click($event) {
          return _vm.selectOption(item, index);
        }
      }
    }, [_vm._t("default", null, {
      "item": item,
      "index": index
    })], 2);
  })], 2), _c("div", {
    class: [_vm.state.search.show ? "flex flex-col flex-auto" : "hidden"],
    attrs: {
      "data-tag": "tiny-select-mobile-box"
    }
  }, [_c("div", {
    staticClass: "flex leading-6 pt-4 pb-4 px-4 text-base items-center",
    attrs: {
      "data-tag": "tiny-select-mobile-header"
    }
  }, [_c("div", {
    staticClass: "flex-auto flex items-center h-8 py-1 px-3 bg-color-bg-4 rounded-full"
  }, [_c("IconSearch", {
    staticClass: "mr-1 fill-color-icon-disabled",
    attrs: {
      "custom-class": "h-4 w-4"
    }
  }), _c("input", {
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.state.search.input,
      expression: "state.search.input"
    }],
    staticClass: "h-5 flex-auto text-xs bg-transparent outline-0",
    attrs: {
      "placeholder": _vm.t("ui.select.pleaseSearch")
    },
    domProps: {
      "value": _vm.state.search.input
    },
    on: {
      "input": [function($event) {
        if ($event.target.composing) return;
        _vm.$set(_vm.state.search, "input", $event.target.value);
      }, _vm.searchMethod]
    }
  })], 1), _c("div", {
    staticClass: "flex items-center pl-3 cursor-pointer"
  }, [_c("div", {
    on: {
      "click": function click($event) {
        return _vm.searchBoxToggle(false);
      }
    }
  }, [_vm._v(_vm._s(_vm.t("ui.base.cancel")))])])]), _c("div", {
    staticClass: "flex-auto overflow-auto flex flex-col",
    attrs: {
      "data-tag": "tiny-select-mobile-body"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.search.filterOptions.length,
      expression: "state.search.filterOptions.length"
    }],
    class: ["flex flex-col px-4"],
    attrs: {
      "data-tag": "tiny-select-mobile-filter"
    }
  }, _vm._l(_vm.state.search.filterOptions, function(item, index) {
    return _c("tiny-option", {
      key: item[_vm.valueField],
      attrs: {
        "multiple": _vm.multiple,
        "ellipsis": _vm.ellipsis,
        "text-field": _vm.textField,
        "text-field2": _vm.textField2,
        "text-field3": _vm.textField3,
        "option": item,
        "selected": _vm.isSelected(item)
      },
      on: {
        "click": function click($event) {
          return _vm.searchSelectHandler(item, index);
        }
      }
    }, [_vm.searchConfig.openSearchSlot ? _vm._t("search-item", null, {
      "item": item,
      "index": index
    }) : _vm._t("default", null, {
      "item": item,
      "index": index
    })], 2);
  }), 1), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.state.search.filterOptions.length,
      expression: "!state.search.filterOptions.length"
    }],
    staticClass: "w-full flex justify-center items-center text-center flex-auto",
    attrs: {
      "data-tag": "tiny-select-mobile-nodata"
    }
  }, [_c("tiny-exception", {
    attrs: {
      "component-page": "",
      "type": "nodata",
      "tiny_mode": "mobile-first",
      "tiny_mode_root": ""
    },
    scopedSlots: _vm._u([{
      key: "content",
      fn: function fn() {
        return [_c("span", {
          staticClass: "text-color-icon-secondary"
        }, [_vm._v(_vm._s(_vm.t("ui.select.noSearchData")))])];
      },
      proxy: true
    }])
  })], 1)])])])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var SelectMobile = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.23.0";
SelectMobile.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
SelectMobile.install = function(Vue) {
  Vue.component(SelectMobile.name, SelectMobile);
};
SelectMobile.version = version;

export { SelectMobile as default };
